<?php
declare(strict_types = 1);
namespace app\common\controller;

use app\common\imtrait\ImTrait;

abstract class AdminBase extends Base
{
    use ImTrait;
    protected $list_nav;
    protected $list_file;
    protected $list_search;

    protected function initialize()
    {
        parent::initialize();
        $this->space_name = 'admin';
        $this->AdminLogin();
        $this->AdminAuth();
        $this->getdata['status'] = $this->getdata['status'] ?? 'a';
        //  设置模板
        $this->request->viewconf = $this->SetView(['app' => $this->space_name,'default_dir' => $this->webdb['web_template_admin'] ?: 'default']);
    }

    protected function AdminAuth(){
        $_controller = explode("\\",$this->request->controller);
        $_controller = end($_controller);
        if($_controller != 'Login'){
            $this->CheckAuth(['read','create','edit','del']);
        }
        return true;
    }
    protected function AdminLogin(){
        $session = $this->request->session();
        $_controller = explode("\\",$this->request->controller);
        $_controller = end($_controller);
        if(!$session->has('_eru_') && $_controller != 'Login'){
            ResRedirect(route('admin.Login.index'),'0');
        }
        if($session->has('_eru_') && $_controller == 'Login' && $this->request->action != 'out'){
            ResRedirect(route('admin.Login.index'),'0');
        }
        return true;
    }
}